unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ExtCtrls, synaser, registry, strings, Math, strutils;

type

  { TForm1 }

  TForm1 = class(TForm)
    Image1: TImage;
    relayCheckBox10: TCheckBox;
    statusLabel: TLabel;
    setAllButton: TButton;
    resetAllButton: TButton;
    openButton: TButton;
    closeButton: TButton;
    listComboBox: TComboBox;
    relayCheckBox16: TCheckBox;
    relayCheckBox1: TCheckBox;
    relayCheckBox11: TCheckBox;
    relayCheckBox12: TCheckBox;
    relayCheckBox13: TCheckBox;
    relayCheckBox14: TCheckBox;
    relayCheckBox15: TCheckBox;
    relayCheckBox2: TCheckBox;
    relayCheckBox3: TCheckBox;
    relayCheckBox4: TCheckBox;
    relayCheckBox5: TCheckBox;
    relayCheckBox6: TCheckBox;
    relayCheckBox7: TCheckBox;
    relayCheckBox8: TCheckBox;
    relayCheckBox9: TCheckBox;
    procedure closeButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure openButtonClick(Sender: TObject);
    procedure relayCheckBox10Change(Sender: TObject);
    procedure relayCheckBox11Change(Sender: TObject);
    procedure relayCheckBox12Change(Sender: TObject);
    procedure relayCheckBox13Change(Sender: TObject);
    procedure relayCheckBox14Change(Sender: TObject);
    procedure relayCheckBox15Change(Sender: TObject);
    procedure relayCheckBox16Change(Sender: TObject);
    procedure relayCheckBox1Click(Sender: TObject);
    procedure relayCheckBox2Change(Sender: TObject);
    procedure relayCheckBox3Change(Sender: TObject);
    procedure relayCheckBox4Change(Sender: TObject);
    procedure relayCheckBox5Change(Sender: TObject);
    procedure relayCheckBox6Change(Sender: TObject);
    procedure relayCheckBox7Change(Sender: TObject);
    procedure relayCheckBox8Change(Sender: TObject);
    procedure relayCheckBox9Change(Sender: TObject);
    procedure resetAllButtonClick(Sender: TObject);
    procedure setAllButtonClick(Sender: TObject);
    procedure GetRelaysStatus;
    procedure sendCommand(command: string);
  private
    { private declarations }
  public
    function GetSerialPortNames: string;
    { public declarations }
  end;

var
  Form1: TForm1;
  serialPort: TBlockSerial;
  respondBuffer: array [0..10] of byte;
  sendBuffer: string;

implementation

{$R *.lfm}

{ TForm1 }
function TForm1.GetSerialPortNames: string;
var
  reg: TRegistry;
  l, v: TStringList;
  n: integer;
begin
  l := TStringList.Create;
  v := TStringList.Create;
  reg := TRegistry.Create;
  try
{$IFNDEF VER100}
    reg.Access := KEY_READ;
{$ENDIF}
    reg.RootKey := HKEY_LOCAL_MACHINE;
    reg.OpenKeyReadOnly('HARDWARE\DEVICEMAP\SERIALCOMM');
    reg.GetValueNames(l);
    for n := 0 to l.Count - 1 do
      v.Add(reg.ReadString(l[n]));
    Result := v.CommaText;
  finally
    reg.Free;
    l.Free;
    v.Free;
  end;
end;

procedure TForm1.GetRelaysStatus;
var
  length: integer;
  checkBoxEvents: array[1..16] of TNotifyEvent;
begin
  respondBuffer[0] := 100;
  respondBuffer[1] := 200;
  try
    begin
      serialPort.SendString('ask//');

      while not (serialPort.LastError <> 0) do
      begin
        if serialPort.lastError <> 0 then
        begin
          statusLabel.Caption := 'could not send';
          break;
        end;
        checkBoxEvents[1] := relayCheckBox1.OnClick;
        checkBoxEvents[2] := relayCheckBox2.OnClick;
        checkBoxEvents[3] := relayCheckBox3.OnClick;
        checkBoxEvents[4] := relayCheckBox4.OnClick;
        checkBoxEvents[5] := relayCheckBox5.OnClick;
        checkBoxEvents[6] := relayCheckBox6.OnClick;
        checkBoxEvents[7] := relayCheckBox7.OnClick;
        checkBoxEvents[8] := relayCheckBox8.OnClick;
        checkBoxEvents[9] := relayCheckBox9.OnClick;
        checkBoxEvents[10] := relayCheckBox10.OnClick;
        checkBoxEvents[11] := relayCheckBox11.OnClick;
        checkBoxEvents[12] := relayCheckBox12.OnClick;
        checkBoxEvents[13] := relayCheckBox13.OnClick;
        checkBoxEvents[14] := relayCheckBox14.OnClick;
        checkBoxEvents[15] := relayCheckBox15.OnClick;
        checkBoxEvents[16] := relayCheckBox16.OnClick;

        relayCheckBox1.OnClick := nil;
        relayCheckBox2.OnClick := nil;
        relayCheckBox3.OnClick := nil;
        relayCheckBox4.OnClick := nil;
        relayCheckBox5.OnClick := nil;
        relayCheckBox6.OnClick := nil;
        relayCheckBox7.OnClick := nil;
        relayCheckBox8.OnClick := nil;
        relayCheckBox9.OnClick := nil;
        relayCheckBox10.OnClick := nil;
        relayCheckBox10.OnClick := nil;
        relayCheckBox10.OnClick := nil;
        relayCheckBox10.OnClick := nil;
        relayCheckBox10.OnClick := nil;
        relayCheckBox10.OnClick := nil;
        relayCheckBox10.OnClick := nil;

        length := serialPort.RecvBuffer(@respondBuffer, 2);
        if (length = 2) then
        begin
          relayCheckBox1.OnClick := nil;
          if ((respondBuffer[0] and $80) > 0) then
            relayCheckBox1.Checked := True
          else
            relayCheckBox1.Checked := False;
          if ((respondBuffer[0] and $40) > 0) then
            relayCheckBox2.Checked := True
          else
            relayCheckBox2.Checked := False;
          if ((respondBuffer[0] and $20) > 0) then
            relayCheckBox3.Checked := True
          else
            relayCheckBox3.Checked := False;
          if ((respondBuffer[0] and $10) > 0) then
            relayCheckBox4.Checked := True
          else
            relayCheckBox4.Checked := False;
          if ((respondBuffer[0] and $08) > 0) then
            relayCheckBox5.Checked := True
          else
            relayCheckBox5.Checked := False;
          if ((respondBuffer[0] and $04) > 0) then
            relayCheckBox6.Checked := True
          else
            relayCheckBox6.Checked := False;
          if ((respondBuffer[0] and $02) > 0) then
            relayCheckBox7.Checked := True
          else
            relayCheckBox7.Checked := False;
          if ((respondBuffer[0] and $01) > 0) then
            relayCheckBox8.Checked := True
          else
            relayCheckBox8.Checked := False;
          if ((respondBuffer[1] and $80) > 0) then
            relayCheckBox9.Checked := True
          else
            relayCheckBox9.Checked := False;
          if ((respondBuffer[1] and $40) > 0) then
            relayCheckBox10.Checked := True
          else
            relayCheckBox10.Checked := False;
          if ((respondBuffer[1] and $20) > 0) then
            relayCheckBox11.Checked := True
          else
            relayCheckBox11.Checked := False;
          if ((respondBuffer[1] and $10) > 0) then
            relayCheckBox12.Checked := True
          else
            relayCheckBox12.Checked := False;
          if ((respondBuffer[1] and $08) > 0) then
            relayCheckBox13.Checked := True
          else
            relayCheckBox13.Checked := False;
          if ((respondBuffer[1] and $04) > 0) then
            relayCheckBox14.Checked := True
          else
            relayCheckBox14.Checked := False;
          if ((respondBuffer[1] and $02) > 0) then
            relayCheckBox15.Checked := True
          else
            relayCheckBox15.Checked := False;
          if ((respondBuffer[1] and $01) > 0) then
            relayCheckBox16.Checked := True
          else
            relayCheckBox16.Checked := False;

          relayCheckBox1.OnClick := checkBoxEvents[1];
          relayCheckBox2.OnClick := checkBoxEvents[2];
          relayCheckBox3.OnClick := checkBoxEvents[3];
          relayCheckBox4.OnClick := checkBoxEvents[4];
          relayCheckBox5.OnClick := checkBoxEvents[5];
          relayCheckBox6.OnClick := checkBoxEvents[6];
          relayCheckBox7.OnClick := checkBoxEvents[7];
          relayCheckBox8.OnClick := checkBoxEvents[8];
          relayCheckBox9.OnClick := checkBoxEvents[9];
          relayCheckBox10.OnClick := checkBoxEvents[10];
          relayCheckBox10.OnClick := checkBoxEvents[11];
          relayCheckBox10.OnClick := checkBoxEvents[12];
          relayCheckBox10.OnClick := checkBoxEvents[13];
          relayCheckBox10.OnClick := checkBoxEvents[14];
          relayCheckBox10.OnClick := checkBoxEvents[15];
          relayCheckBox10.OnClick := checkBoxEvents[16];
          break;
        end;
      end;
    end
  except
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  names: string;
  namesList: TStringList;
  temp_names: string;
begin
  names := GetSerialPortNames();
  namesList := TStringList.Create();
  ExtractStrings([','], [], PChar(names), namesList);
  for temp_names in namesList do
  begin
    listComboBox.Items.Add(temp_names);
    listComboBox.ItemIndex := 0;
  end;
  namesList.Free;
  statusLabel.Caption := 'Select Port and Press Open';

  serialPort := TBlockSerial.Create;
end;

procedure TForm1.closeButtonClick(Sender: TObject);
begin
  try
  serialPort.CloseSocket;
  finally
  end;
  statusLabel.Caption:='Port Closed';
end;

procedure TForm1.openButtonClick(Sender: TObject);
begin
  respondBuffer[0] := 100;
  respondBuffer[1] := 200;
  try
    begin
      serialPort.Config(9600, 8, 'N', SB1, False, False);
      serialPort.Connect(listComboBox.Text);
      GetRelaysStatus;
      statusLabel.Caption := 'Port Opened successfully';
    end
  except
  end;
end;

procedure TForm1.relayCheckBox10Change(Sender: TObject);
begin
  if relayCheckBox10.Checked then
    sendBuffer := '10+//'
  else
    sendBuffer := '10-//';
  sendCommand(sendBuffer);
end;

procedure TForm1.relayCheckBox11Change(Sender: TObject);
begin
  if relayCheckBox11.Checked then
    sendBuffer := '11+//'
  else
    sendBuffer := '11-//';
  sendCommand(sendBuffer);
end;

procedure TForm1.relayCheckBox12Change(Sender: TObject);
begin
  if relayCheckBox12.Checked then
    sendBuffer := '12+//'
  else
    sendBuffer := '12-//';
  sendCommand(sendBuffer);
end;

procedure TForm1.relayCheckBox13Change(Sender: TObject);
begin
  if relayCheckBox13.Checked then
    sendBuffer := '13+//'
  else
    sendBuffer := '13-//';
  sendCommand(sendBuffer);
end;

procedure TForm1.relayCheckBox14Change(Sender: TObject);
begin
  if relayCheckBox14.Checked then
    sendBuffer := '14+//'
  else
    sendBuffer := '14-//';
  sendCommand(sendBuffer);
end;

procedure TForm1.relayCheckBox15Change(Sender: TObject);
begin
  if relayCheckBox15.Checked then
    sendBuffer := '15+//'
  else
    sendBuffer := '15-//';
  sendCommand(sendBuffer);
end;

procedure TForm1.relayCheckBox16Change(Sender: TObject);
begin
  if relayCheckBox16.Checked then
    sendBuffer := '16+//'
  else
    sendBuffer := '16-//';
  sendCommand(sendBuffer);
end;

procedure TForm1.relayCheckBox1Click(Sender: TObject);
begin
  if relayCheckBox1.Checked then
    sendBuffer := '01+//'
  else
    sendBuffer := '01-//';
  sendCommand(sendBuffer);
end;

procedure TForm1.relayCheckBox2Change(Sender: TObject);
begin
  if relayCheckBox2.Checked then
    sendBuffer := '02+//'
  else
    sendBuffer := '02-//';
  sendCommand(sendBuffer);
end;

procedure TForm1.relayCheckBox3Change(Sender: TObject);
begin
  if relayCheckBox3.Checked then
    sendBuffer := '03+//'
  else
    sendBuffer := '03-//';
  sendCommand(sendBuffer);
end;

procedure TForm1.relayCheckBox4Change(Sender: TObject);
begin
  if relayCheckBox4.Checked then
    sendBuffer := '04+//'
  else
    sendBuffer := '04-//';
  sendCommand(sendBuffer);
end;

procedure TForm1.relayCheckBox5Change(Sender: TObject);
begin
  if relayCheckBox5.Checked then
    sendBuffer := '05+//'
  else
    sendBuffer := '05-//';
  sendCommand(sendBuffer);
end;

procedure TForm1.relayCheckBox6Change(Sender: TObject);
begin
  if relayCheckBox6.Checked then
    sendBuffer := '06+//'
  else
    sendBuffer := '06-//';
  sendCommand(sendBuffer);
end;

procedure TForm1.relayCheckBox7Change(Sender: TObject);
begin
  if relayCheckBox7.Checked then
    sendBuffer := '07+//'
  else
    sendBuffer := '07-//';
  sendCommand(sendBuffer);
end;

procedure TForm1.relayCheckBox8Change(Sender: TObject);
begin
  if relayCheckBox8.Checked then
    sendBuffer := '08+//'
  else
    sendBuffer := '08-//';
  sendCommand(sendBuffer);
end;

procedure TForm1.relayCheckBox9Change(Sender: TObject);
begin
  if relayCheckBox9.Checked then
    sendBuffer := '09+//'
  else
    sendBuffer := '09-//';
  sendCommand(sendBuffer);
end;

procedure TForm1.resetAllButtonClick(Sender: TObject);
begin
  sendCommand('off//');
  GetRelaysStatus;
end;

procedure TForm1.setAllButtonClick(Sender: TObject);
begin
  sendCommand('on//');
  GetRelaysStatus;
end;

procedure TForm1.sendCommand(command: string);
var
  strLength: integer;
  hasError : Boolean = true;
begin
  try
    begin
      serialPort.SendString(command);
      while not (serialPort.LastError <> 0) do
      begin
        if serialPort.lastError <> 0 then
        begin
          statusLabel.Caption := 'Could not send';
          break;
        end;
        strLength := serialPort.RecvBuffer(@respondBuffer, length(command));
        if (strLength = length(command)) then
        begin
          hasError := False;
          break;
        end;
      end;
      GetRelaysStatus;
    end
  except
  end;
  if hasError then
      statusLabel.Caption := 'Port not opened';
end;

end.
